/*
NSIM is a simulator for the processor used in the HP-41 (Nut) and in the HP
Series 10 (Voyager) calculators.

$Id: rom.h 57 2003-10-29 03:09:15Z eric $
Copyright 1995, 2003 Eric Smith <eric@brouhaha.com>

NSIM is free software; you can redistribute it and/or modify it under the
terms of the GNU General Public License version 2 as published by the Free
Software Foundation.  Note that I am not granting permission to redistribute
or modify NSIM under the terms of any later version of the General Public
License.

This program is distributed in the hope that it will be useful (or at least
amusing), but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
Public License for more details.

You should have received a copy of the GNU General Public License along with
this program (in the file "COPYING"); if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

$Header: /home/yl2/eric/hpcalc/nasm/RCS/rom.h,v 1.1 1995/07/30 18:34:58 eric Exp eric $
*/


#define MAX_BANK 4
#define MAX_PAGE 16
#define PAGE_SIZE 4096
#define MAX_ROM 65536

#define HW_NONE   0
#define HW_ROM    1
#define HW_RAM    2
#define HW_RAM_WP 4
#define HW_HEPAX  8

/*
 * set breakpoints at every location so we know if we hit
 * uninitialized ROM
 */
void init_rom (void);

void register_hwpage(int p, int bank, int hw, char*desc);
void set_ucode  (address a, int b, romword val);
void set_bpt    (address a, int b, bool val);
void set_source (address a, int b, char *val);

int get_hwpage(int page, int bank);
romword get_ucode (address a);
bool get_bpt      (address a);
char *get_source  (address a);

void reset_bank    (void);
void select_bank (address a, int b);
int get_active_bank(int p);

void write_page ();
void move_page       (int sp, int dp);
void reset_moved_page(void);

void show_pages(void);
